
// A case study on how to implement I2C routines for TI-92+
// (c) ASkr 2007


#define SAVE_SCREEN         // this directive forces saving/restoring the screen

#define USE_TI89            // produce all types of files
#define USE_TI92PLUS
#define USE_V200

#include <stdio.h> 
#include <kbd.h>
#include <args.h>
#include <estack.h>
#include <mem.h>
#include <peekpoke.h>

//void _I2CSend(unsigned char *adda) __attribute__((regparm(1)));
void _I2CSend(unsigned char *adda) __attribute__((regparm(1)));
void _I2CRecv(unsigned char *adda) __attribute__((regparm(1)));


//***************************************************************************
//*** LinkInit
//***
//***************************************************************************
void LinkInit()
{
	pokeIO_bset(0x60000C,6);
}


//***************************************************************************
//*** LinkExit
//***
//***************************************************************************
void LinkExit()
{
	// Reset data lines to logic low.
	// Otherwise, the calculator will turn itself
	// on because a high signal activates reception...
	pokeIO_bclr(0x60000E,0);
	pokeIO_bclr(0x60000E,1);
	pokeIO_bclr(0x60000C,6);
}




//***************************************************************************
//*** TurboProtSend
//*** 
//***************************************************************************
void TurboProtSend(unsigned char data)
{
	asm("	move.b #8,%%d1;0:
				ror #1,%[data]
				bcc 1f
				bchg #0,0x60000E
				bra 2f
				1:
				bchg #1,0x60000E
				2:
				dbra %%d1,0b"
				: // nothing
				: [data] "d" (data)
				: "d1"
			);

}



//***************************************************************************
//*** Main
//***
//***************************************************************************
void _main(void)
{
  ESI argptr = top_estack;

  unsigned char a = GetIntArg (argptr);
  unsigned char SendStr[20];

  while (GetArgType (top_estack) != END_TAG)
    top_estack = next_expression_index (top_estack);
  top_estack--;

  clrscr();
  
	LinkInit();

//	TurboProtSend(a);
	SendStr[0]=0x02;			// 3 bytes to send (including address)
	SendStr[1]=0x42;			// address including R/W Bit
	SendStr[2]=a;					// Data 0
	_I2CSend((unsigned char *)&SendStr);

	LinkExit();	

}
