| Assembly Source File
| Created 22.02.2007; 16:00:03
| (c) ASkr

| Oh my, the last time I did assembler on 68k, it was
| an Atari. And hell, this was about ~15 years ago ;)


	.text
	.xdef _I2CSend

| Args incoming:
|  a0 -> points to byte string

_I2CSend:
	movem.l	%d0-%d2,-(%sp)		| save regs

	move.l	#0,%d0			| just in case...
	move.b	(%a0)+,%d0		| d0 holds byte counter (incl. addr)
	subq.w	#1,%d0			| correction for "dbra d0,<loop>"
	bmi	_End			| out if input length was 0

	bset	#1,0x60000E		| (START) pull down SDA

_AllBytes:
	move.l	#7,%d1			| 8 bits per transfer
	move.b	(%a0)+,%d2		| d2 holds byte to send

_AllBits:
	bset	#0,0x60000E		| SCL goes L
	rol.b	#1,%d2
	bcc	_SetDL
	bclr	#1,0x60000E		| SDA goes H
	bra	_SetDone
_SetDL:
	bset	#1,0x60000E		| SDA goes L
_SetDone:
	bclr	#0,0x60000E		| SCL goes H

	dbra	%d1,_AllBits		| Repeat for all bits

	| TODO:
	| Check for ACK/NACK TIMEOUT
	bset	#0,0x60000E		| SCL goes L
	bclr	#1,0x60000E		| SDA goes H

	btst	#3,0x60000E		| (ACK) bit is set, if ACK was there
	bne	_AckOk

	bclr	#0,0x60000E		| (ERROR/NACK) abort transfer
	bra	_End
	
_AckOk:	
	bclr	#0,0x60000E		| SCL goes H

	dbra	%d0,_AllBytes		| Repeat for all bytes

	bclr	#1,0x60000E		| (STOP) SCL was high, SDA goes H
_End:

	movem.l (%sp)+,%d0-%d2

	rts



_I2CRecv:
	rts
